-- Test add_service
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(12);

set search_path to camper, public;

select has_function('camper', 'add_service', array['integer', 'text', 'text', 'text']);
select function_lang_is('camper', 'add_service', array['integer', 'text', 'text', 'text'], 'sql');
select function_returns('camper', 'add_service', array['integer', 'text', 'text', 'text'], 'integer');
select isnt_definer('camper', 'add_service', array['integer', 'text', 'text', 'text']);
select volatility_is('camper', 'add_service', array['integer', 'text', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'add_service', array ['integer', 'text', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'add_service', array ['integer', 'text', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'add_service', array ['integer', 'text', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'add_service', array ['integer', 'text', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate service cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
     , (2, 'Company 4', 'XX234', '', '666-666-666', 'b@b', '', '', '', '', '', '', 60, 7, 'FR', 'USD', 'ca')
;

select lives_ok(
	$$ select add_service(1, 'information', 'Info', '<!-- block --><h2>This is what, exactly?</h2><!-- /block --><p>Dunno</p>') $$,
	'Should be able to add a service to the first company'
);

select lives_ok(
	$$ select add_service(2, 'toilet', 'Is this Google?', '') $$,
	'Should be able to add a service to the second company'
);

select bag_eq(
	$$ select company_id, icon_name, name, description::text from service $$,
	$$ values (1, 'information', 'Info', '<!-- block --><h2>This is what, exactly?</h2><!-- /block --><p>Dunno</p>')
	        , (2, 'toilet', 'Is this Google?', '')
	$$,
	'Should have added all two service'
);


select *
from finish();

rollback;
